/**
 *
 * Created by Kyle Benk kjbenk@gmail.com
 *
 * 12/14
 */

jQuery(document).ready(function($) {

	// Load stats via AJAX

	$.post(ajaxurl, {
			'action': 'wps_bt_stats_load',
			'start_date' : getQuerystring(wps_bt_stats_data.prefix_dash + 'start-date'),
			'end_date' : getQuerystring(wps_bt_stats_data.prefix_dash + 'end-date'),
			'background_takeover_name' : getQuerystring('background_takeover_name'),
			'background_takeover_id' : getQuerystring('background_takeover_id', false)}, function(response) {

		response = jQuery.parseJSON(response);

		$("#" + wps_bt_stats_data.prefix_dash + "loading-stats").remove();
		$(response.stats_content).insertAfter("#" + wps_bt_stats_data.prefix_dash + "before-table");

		if ($("#" + wps_bt_stats_data.prefix_dash + "line-graph").length != 0) {

			var dates = [];
			var background_takeovers = [];
			var impressions = [];
			var clicks = [];
			var max_name_length = 13;

			$.each(response.background_takeover_stats, function(key, value){
				$.each(value, function(key_1, value_1){

					if (key_1 == 'background_takeover_name') {
						background_takeovers.push(value_1);
					}

					if (key_1 == 'date') {
						dates.push(value_1);
					}

					if (key_1 == 'impressions') {
						impressions.push(value_1);
					}

					if (key_1 == 'left_clicks') {
						clicks.push(value_1);
					}

					if (key_1 == 'right_clicks') {
						clicks[clicks.length - 1] = Number(value_1) + Number(clicks[clicks.length - 1]);
					}
				});
			});


			if (getQuerystring('background_takeover_name') != '') {
				var labels = dates;
			} else {
				var labels = background_takeovers;
			}


			// Line Graph

			var lineChartData = {
				labels : labels,
				datasets : [
					{
						label: "Impressions",
						fillColor : "rgba(220, 181, 69, 0.2)",
						strokeColor : "rgba(220, 181, 69, 1)",
						pointColor : "rgba(220, 181, 69, 1)",
						pointStrokeColor : "#fff",
						pointHighlightFill : "#fff",
						pointHighlightStroke : "rgba(220, 181, 69, 1)",
						data : impressions
					},
					{
						label: "Clicks",
						fillColor : "rgba(81, 66, 205, 0.2)",
						strokeColor : "rgba(81, 66, 205, 1)",
						pointColor : "rgba(81, 66, 205, 1)",
						pointStrokeColor : "#fff",
						pointHighlightFill : "#fff",
						pointHighlightStroke : "rgba(81, 66, 205, 1)",
						data : clicks
					}
				]

			}

			// Show No stats

			if (impressions.length == 0) {

				var lineChartData = {
					labels : ['1-1-1970','1-2-1970','1-3-1970','1-4-1970','1-5-1970','1-6-1970','1-7-1970','1-8-1970','1-9-1970'],
					datasets : [
						{
							label: "Impressions",
							fillColor : "rgba(220, 181, 69, 0.2)",
							strokeColor : "rgba(220, 181, 69, 1)",
							pointColor : "rgba(220, 181, 69, 1)",
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : "rgba(220, 181, 69, 1)",
							data : ['25','45','43','18','26','34','21','20','29']
						},
						{
							label: "Clicks",
							fillColor : "rgba(81, 66, 205, 0.2)",
							strokeColor : "rgba(81, 66, 205, 1)",
							pointColor : "rgba(81, 66, 205, 1)",
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : "rgba(81, 66, 205, 1)",
							data : ['12','3','8','6','11','6','3','5','7']
						}
					]

				}

				var ctx = document.getElementById(wps_bt_stats_data.prefix_dash + "line-graph").getContext("2d");
				window.myLine = new Chart(ctx).Line(lineChartData, {
					responsive: true,
				});
				$('#' + wps_bt_stats_data.prefix_dash + 'line-graph').css('opacity', '0.5');
				$('<h3 style="width: 70%;text-align: center;position: absolute;margin-top: 60px;">Example Data</h3><h3 style="width: 70%;text-align: center;position: absolute;margin-top: 100px;">No Stats Yet</h3>').insertBefore('#' + wps_bt_stats_data.prefix_dash + 'line-graph');
			}

			// Show Line graph if there are multiple stats

			else if (impressions.length > 1 && getQuerystring('background_takeover_name') != '') {
				var ctx = document.getElementById(wps_bt_stats_data.prefix_dash + "line-graph").getContext("2d");
				window.myLine = new Chart(ctx).Line(lineChartData, {
					responsive: true,
				});
			}

			// Show Bar graph if there is only one day of stats  or on all Firebar stats page

			else {
				var ctx = document.getElementById(wps_bt_stats_data.prefix_dash + "line-graph").getContext("2d");
				window.myLine = new Chart(ctx).Bar(lineChartData, {
					responsive: true,
				});
			}
		}
	});

	// Date Pickers

	$('#' + wps_bt_stats_data.prefix_dash + 'start-datepicker').datetimepicker({
                    pickTime: false
                });
	$('#' + wps_bt_stats_data.prefix_dash + 'end-datepicker').datetimepicker({
                    pickTime: false
                });

	$('#' + wps_bt_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").setMaxDate($('#' + wps_bt_stats_data.prefix_dash + 'end-datepicker').data("DateTimePicker").getDate());
	$('#' + wps_bt_stats_data.prefix_dash + 'end-datepicker').data("DateTimePicker").setMinDate($('#' + wps_bt_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").getDate());
	$('#' + wps_bt_stats_data.prefix_dash + 'end-datepicker').data("DateTimePicker").setMaxDate(wps_bt_stats_data.today.toString());

	$('#' + wps_bt_stats_data.prefix_dash + 'start-datepicker').on("dp.change",function (e) {
       $('#' + wps_bt_stats_data.prefix_dash + 'end-datepicker').data("DateTimePicker").setMinDate(e.date);
    });
    $('#' + wps_bt_stats_data.prefix_dash + 'end-datepicker').on("dp.change",function (e) {
       $('#' + wps_bt_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").setMaxDate(e.date);
    });

    function getQuerystring(key, default_) {
	  if (default_==null) default_="";
	  key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
	  var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
	  var qs = regex.exec(window.location.href);
	  if(qs == null)
	    return default_;
	  else
	    return qs[1];
	}
});