<?php
/*
Plugin Name: WPsite Background Takeover
Plugin URI:
Description: Adds wallpaper to the background of your website
Version: 3.0.3
Author: WPSITE.NET
Author URI: http://wpsite.net
License: GPL2
*/

/**
 * Global Definitions
 */

/* Item Name */

if (!defined('WPSITE_WALLPAPER_TAKEOVER_ITEM_NAME'))
    define('WPSITE_WALLPAPER_TAKEOVER_ITEM_NAME', 'WP Background Takeover Advertisements');

/* Store URL */

if (!defined('WPSITE_WALLPAPER_TAKEOVER_STORE_URL'))
    define('WPSITE_WALLPAPER_TAKEOVER_STORE_URL', 'https://99robots.com');

/* Plugin Name */

if (!defined('WPSITE_WALLPAPER_TAKEOVER_PLUGIN_NAME'))
    define('WPSITE_WALLPAPER_TAKEOVER_PLUGIN_NAME', trim(dirname(plugin_basename(__FILE__)), '/'));

/* Plugin directory */

if (!defined('WPSITE_WALLPAPER_TAKEOVER_PLUGIN_DIR'))
    define('WPSITE_WALLPAPER_TAKEOVER_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . WPSITE_WALLPAPER_TAKEOVER_PLUGIN_NAME);

/* Plugin url */

if (!defined('WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL'))
    define('WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL', WP_PLUGIN_URL . '/' . WPSITE_WALLPAPER_TAKEOVER_PLUGIN_NAME);

/* Plugin verison */

if (!defined('WPSITE_WALLPAPER_TAKEOVER_VERSION_NUM'))
    define('WPSITE_WALLPAPER_TAKEOVER_VERSION_NUM', '3.0.3');

// Date Format

if (!defined('WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT'))
    define('WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT', 'Y-m-d');


/**
 * Activatation / Deactivation
 */

register_activation_hook( __FILE__, 							array('WPsite_Wallpaper_Takeover', 'register_activation'));


/**
 * Hooks / Filter
 */

add_action('init', 												array('WPsite_Wallpaper_Takeover', 'wpsite_init'));
add_action('admin_menu', 										array('WPsite_Wallpaper_Takeover', 'ad_control_menu_wpto'));
add_action('wp_footer', 										array('WPsite_Wallpaper_Takeover', 'is_home_wpto'));
add_action('wp_ajax_wps_bt_stats_load', 						array('WPsite_Wallpaper_Takeover', 'stats_load'));

add_action('wp_ajax_wps_bt_license_action', 					array('WPsite_Wallpaper_Takeover', 'license_action'));

// Cron Jobs

add_action('initialize_background_takeover_stats_daily_cron', 	array('WPsite_Wallpaper_Takeover', 'initialize_background_takeover_stats_daily'), 10 ,2 );

include_once(dirname(__FILE__) . "/include/classes/wpsite-stats-bt.php");

// Software Licensing Updates

if ( !class_exists('EDD_SL_Plugin_Updater') ) {
	include_once( dirname( __FILE__ ) . '/include/edd-software-licensing-updates/EDD_SL_Plugin_Updater.php' );
}

$edd_updater = new EDD_SL_Plugin_Updater( WPSITE_WALLPAPER_TAKEOVER_STORE_URL , __FILE__, array(
		'version' 	=> WPSITE_WALLPAPER_TAKEOVER_VERSION_NUM,
		'license' 	=> WPsite_Wallpaper_Takeover::get_license_key(),
		'item_name' => WPSITE_WALLPAPER_TAKEOVER_ITEM_NAME,
		'author' 	=> '99 Robots',
	)
);

/*
 * Class used to create the back-end controls and settings
 *
 * @since 1.0
 */
class WPsite_Wallpaper_Takeover {

	/**
	 * default_args
	 *
	 * @var mixed
	 * @access private
	 * @static
	 */
	private static $default_args = array(
		'post_types' => ''
	);

	/**
	 * default_global_settings
	 *
	 * @var mixed
	 * @access private
	 * @static
	 */
	private static $default_global_settings = array(
		'dom_element'	=> 'body',
		'mobile'		=> false,
	);

	/**
	 * dashboard_page
	 *
	 * (default value: 'ad-control-wpto')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	private static $dashboard_page = 'ad-control-wpto';

	/**
	 * add_new_page
	 *
	 * (default value: 'new-ad-wpto')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	private static $add_new_page = 'new-ad-wpto';

	/**
	 * group_page
	 *
	 * (default value: 'ad-groups-wpto')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	private static $group_page = 'ad-groups-wpto';

	/**
	 * help_page
	 *
	 * (default value: 'ad-help-wpto')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	private static $help_page = 'ad-help-wpto';

	/**
	 * stats_page
	 *
	 * (default value: 'wpsite-background-takeover-stats')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $stats_page = 'wpsite-background-takeover-stats';

	/**
	 * text_domain
	 *
	 * (default value: 'wpsite_wallpaper_takeover')
	 *
	 * @var string
	 * @access private
	 * @static
	 */
	public static $text_domain = 'wpsite_wallpaper_takeover';

	/**
	 * prefix
	 *
	 * (default value: 'wpsite-wallpaper-takeover-')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $prefix = 'wpsite-wallpaper-takeover-';

	/**
	 * prefix_dash
	 *
	 * (default value: 'wps-bt-')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $prefix_dash = 'wps-bt-';

	/**
	 * plugin_name
	 *
	 * (default value: 'WPsite Background Takeover')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $plugin_name = 'WPsite Background Takeover';

	/**
	 * plugin_update_endpoint
	 *
	 * (default value: 'http://versiondata.com/wpsite-background-takeover.json')
	 *
	 * @var string
	 * @access public
	 * @static
	 */
	public static $plugin_update_endpoint = 'http://versiondata.com/wpsite-background-takeover.json';

	/**
	 * Performs tasks needed upon activation
	 *
	 * @since 1.0.0
	 */
	static function register_activation() {

		/* Check if multisite, if so then save as site option */

		if (is_multisite()) {
			add_site_option('wpsite_wallpaper_takeover_version', WPSITE_WALLPAPER_TAKEOVER_VERSION_NUM);
		} else {
			add_option('wpsite_wallpaper_takeover_version', WPSITE_WALLPAPER_TAKEOVER_VERSION_NUM);
		}

		// Change Table name

		global $wpdb;

		$results_new = $wpdb->get_results('SHOW TABLES LIKE "' . $wpdb->prefix . 'wpsite_takeover_ad%"', 'ARRAY_N');

		if (isset($results_new) && is_array($results_new) && count($results_new) == 0) {
			$results_old = $wpdb->get_results('SHOW TABLES LIKE "wpsite_takeover_ad%"', 'ARRAY_N');

			if (isset($results_old) && is_array($results_old) && count($results_old) > 0) {
				foreach ($results_old as $result) {
					$wpdb->query("ALTER TABLE `" . $result[0] . "` RENAME TO `" . $wpdb->prefix . $result[0] . "`;");
				}
			}
		} else {
			$results_old = $wpdb->get_results('SHOW TABLES LIKE "wpsite_takeover_ad%"', 'ARRAY_N');

			if (isset($results_old) && is_array($results_old) && count($results_old) > 0) {
				foreach ($results_new as $result) {
					$wpdb->query("DROP TABLE `" . $result[0] . ";");
				}
				foreach ($results_old as $result) {
					$wpdb->query("ALTER TABLE `" . $result[0] . "` RENAME TO `" . $wpdb->prefix . $result[0] . "`;");
				}
			}
		}

		require_once(dirname(__FILE__)."/include/classes/Ads_DB_WPTO.php");
		$ads_db_wpto = new Ads_DB_WPTO();

		require_once(dirname(__FILE__)."/include/classes/Ad_Groups_DB_WPTO.php");
		$ad_groups_mgn = new Ad_Groups_Mgn();


		// Add Defualt Ad Group

		$groups = $ad_groups_mgn->get_datas();

		if (isset($groups) && !is_array($groups)) {
			$result = $ad_groups_mgn->add_data(array(
				'name' 	=> 'group',
				'notes'	=> 'This is the default ad group similar to Categories'
			));
		} else if (isset($groups) && is_array($groups) && count($groups) <= 0) {
			$result = $ad_groups_mgn->add_data(array(
				'name' 	=> 'group',
				'notes'	=> 'This is the default ad group similar to Categories'
			));
		}

		// Create all tables

		WPsite_Stats_BT::createTable();
	}

	/*
	 * Hook to the 'init' action hook
	 *
	 * @since 1.0
	 */
	static function wpsite_init() {
		load_plugin_textdomain( self::$text_domain, false, dirname(plugin_basename( __FILE__ )).'/languages/');
	}

	/**
	 * Perform all the actions with a license
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function license_action() {

		if ( !isset($_POST['license_key']) ) {
			echo '';
			die();
		}

		// data to send in our API request

		$api_params = array(
			'edd_action'	=> $_POST['license_action'],
			'license' 		=> $_POST['license_key'],
			'item_name' 	=> urlencode( WPSITE_WALLPAPER_TAKEOVER_ITEM_NAME ), // the name of our product in EDD
			'url'       	=> home_url()
		);

		// Call the custom API.

		$response = wp_remote_post( WPSITE_WALLPAPER_TAKEOVER_STORE_URL, array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );

		// make sure the response came back okay

		if ( is_wp_error( $response ) ) {
			echo $response;
			die();
		}

		$license_data = json_decode( wp_remote_retrieve_body( $response ) );

		if ( $_POST['license_action'] != 'check_license' ) {
			self::update_license_key($_POST['license_key']);
		}

		// decode the license data

		echo $license_data->license;

		die();

	}

	/**
	 * Check if license key is active
	 *
	 * @access public
	 * @static
	 * @param mixed $license_key
	 * @return void
	 */
	static function is_license_active( $license_key ) {

		if ( !isset( $license_key ) ) {
			return false;
		}

		// data to send in our API request

		$api_params = array(
			'edd_action'	=> 'check_license',
			'license' 		=> $license_key,
			'item_name' 	=> urlencode( WPSITE_WALLPAPER_TAKEOVER_ITEM_NAME ), // the name of our product in EDD
			'url'       	=> home_url()
		);

		// Call the custom API.

		$response = wp_remote_post( WPSITE_WALLPAPER_TAKEOVER_STORE_URL, array( 'timeout' => 15, 'sslverify' => false, 'body' => $api_params ) );

		// make sure the response came back okay

		if ( is_wp_error( $response ) ) {
			return false;
		}

		$license_data = json_decode( wp_remote_retrieve_body( $response ) );

		// decode the license data

		if ( isset($license_data->license) && $license_data->license == 'valid' ) {
			return true;
		} else {
			return false;
		}

	}

	/**
	 * Get the license key
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_license_key() {

		// Get the license key from based on WordPress install

		if ( function_exists('is_multisite') && is_multisite() ) {
			$license_key = get_site_option(self::$prefix . 'license_key');
		} else {
			$license_key = get_option(self::$prefix . 'license_key');
		}

		// Check if license key is set

		if ( $license_key === false ) {
			$license_key = '';
		}

		return $license_key;
	}

	/**
	 * Update the license key
	 *
	 * @access public
	 * @static
	 * @param mixed $license_key
	 * @return void
	 */
	static function update_license_key($license_key) {

		if ( isset( $license_key ) ) {

			// Get the license key from based on WordPress install

			if ( function_exists('is_multisite') && is_multisite() ) {

				update_site_option(self::$prefix . 'license_key', $license_key);

			} else {

				update_option(self::$prefix . 'license_key', $license_key);

			}

		}

	}

	/*
	 * Hook to create pages
	 *
	 * @since 1.0
	 */
	static function ad_control_menu_wpto() {
		add_menu_page(
			"Background Takeover",
			"Background Takeover",
			'manage_options',
			self::$dashboard_page,
			array('WPsite_Wallpaper_Takeover' ,"ad_dashboard_wpto"),
	    	plugin_dir_url(__FILE__) . 'img/wpsite-menu-icon@2x.png" style="width:25px;');

		$dashboard_page = add_submenu_page(
			self::$dashboard_page,
			"All Ads",
			"All Ads",
			'manage_options',
			self::$dashboard_page,
			array('WPsite_Wallpaper_Takeover', "ad_dashboard_wpto"));
		add_action("admin_print_scripts-$dashboard_page", array('WPsite_Wallpaper_Takeover', 'inline_scripts_dashboard'));

		$add_edit_page = add_submenu_page(
			self::$dashboard_page,
			"Add New",
			"Add New",
			'manage_options',
			self::$add_new_page,
			array('WPsite_Wallpaper_Takeover', "new_ad_wpto"));
		add_action("admin_print_scripts-$add_edit_page", array('WPsite_Wallpaper_Takeover', 'inline_scripts_add_edit'));

		$add_edit_group_page = add_submenu_page(
			self::$dashboard_page,
			"Groups",
			"Groups",
			'manage_options',
			self::$group_page,
			array('WPsite_Wallpaper_Takeover', "ad_groups_wpto"));
		add_action("admin_print_scripts-$add_edit_group_page", array('WPsite_Wallpaper_Takeover', 'inline_scripts_dashboard'));

		$stats_page_load = add_submenu_page(
			self::$dashboard_page,
			__("Stats" , self::$text_domain),
			__("Stats" , self::$text_domain),
			'manage_options',
			self::$stats_page,
			array('WPsite_Wallpaper_Takeover','stats'));
		add_action("admin_print_scripts-$stats_page_load", array('WPsite_Wallpaper_Takeover', 'inline_admin_scripts_stats'));
	}

	/*
	 * Hooks to "admin_print_scripts-$page"
	 *
	 * @since 1.0
	 */
	static function inline_scripts_dashboard() {
		wp_enqueue_style('wallpaper_takeover_admin_css', plugins_url('css/wallpaper_takeover_admin.css', __FILE__));

		wp_enqueue_script('jquery');
		wp_enqueue_script('wpsite_wallpaper_takeover_js', plugins_url('/js/dashboard.js', __FILE__));

		// Font Awesome

		wp_enqueue_style('wpsite_wallpaper_takeover_fontawesome_css', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/fontawesome/css/font-awesome.min.css');

		// Bootstrap

		wp_enqueue_style('wpsite_wallpaper_takeover_bootstrap_css', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/css/bootstrap.css');
		wp_enqueue_script('wpsite_wallpaper_takeover_bootstrap_js', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/js/bootstrap.js', array('jquery'));

		wp_localize_script('wpsite_wallpaper_takeover_js', 'wps_bt_data', array(
			'prefix'			=> self::$prefix_dash,
			'activate_text'		=> __('Activate', self::$text_domain),
			'deactivate_text'	=> __('Deactivate', self::$text_domain),
		));
	}

	/*
	 * Hooks to "admin_print_scripts-$page"
	 *
	 * @since 1.0
	 */
	static function inline_scripts_add_edit() {
		wp_enqueue_style('wallpaper_takeover_admin_css', plugins_url('css/wallpaper_takeover_admin.css', __FILE__));
		wp_enqueue_style('wp-color-picker');
		wp_enqueue_script('wp-color-picker');

		wp_enqueue_script('jquery');
		wp_enqueue_script('wpsite_wallpaper_takeover_js', plugins_url('/js/add-edit.js', __FILE__), array('wp-color-picker'), false, true);

		wp_enqueue_media();

		// Bootstrap

		wp_enqueue_style('wpsite_wallpaper_takeover_bootstrap_datetimepicker_css', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/css/bootstrap-datetimepicker.min.css');
		wp_enqueue_style('wpsite_wallpaper_takeover_bootstrap_css', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/css/bootstrap.css');
		wp_enqueue_script('wpsite_wallpaper_takeover_bootstrap_js', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/js/bootstrap.js', array('jquery'));
		wp_enqueue_script('wpsite_wallpaper_takeover_bootstrap_moment_js', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/js/moment.js', array('jquery'));
		wp_enqueue_script('wpsite_wallpaper_takeover_bootstrap_datetimepicker_js', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/js/bootstrap-datetimepicker.min.js', array('jquery', 'wpsite_wallpaper_takeover_bootstrap_moment_js'));
	}

	/**
	 * Hooks to "admin_print_scripts-$page"
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function inline_admin_scripts_stats() {
	    wp_enqueue_style(self::$prefix . 'settings_css', plugins_url('css/wallpaper_takeover_admin.css', __FILE__));
	    wp_enqueue_style(self::$prefix . 'fontawesome_css', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/fonts/font-awesome.min.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_css', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/css/bootstrap.css');
	    wp_enqueue_style(self::$prefix . 'bootstrap_datetimepicker_css', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/css/bootstrap-datetimepicker.min.css');

	    wp_enqueue_script(self::$prefix . 'line_graph_js', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/js/Chart.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_js', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/js/bootstrap.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_moment_js', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/js/moment.js', array('jquery'));
		wp_enqueue_script(self::$prefix . 'bootstrap_datetimepicker_js', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/include/bootstrap-3.2.0-dist/js/bootstrap-datetimepicker.min.js', array('jquery', self::$prefix . 'bootstrap_moment_js'));
	}

	/*
	 * Callback for dashboard page
	 *
	 * @since 1.0
	 */
	static function ad_dashboard_wpto() {

		$license_key = self::get_license_key();

		// Add cron jobs

		if ( ! wp_next_scheduled('initialize_background_takeover_stats_daily_cron')) {
			wp_schedule_event( time(), 'daily', 'initialize_background_takeover_stats_daily_cron');
		}

		include_once(dirname(__FILE__)."/include/classes/Ads_DB_WPTO.php");
		$adsMgn = new Ads_DB_WPTO();

		$tmp_url = get_admin_url() . "admin.php?page=" . self::$dashboard_page;

		// Delete

		if(isset($_GET["action"]) && $_GET["action"] == "delete") {
			$ad_ids = array();
			$ad_ids = isset($_POST["ad_ids"]) ? $_POST["ad_ids"] : false;
			if(isset($_GET["ad_id"]))
				$ad_ids[] = $_GET["ad_id"];

			for($i = 0; $i < count($ad_ids); $i++)
				$adsMgn->delete_data($ad_ids[$i]);

			?>
			<script type="text/javascript">
				window.location= "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>&message=<?php printf(__('%s was just deleted!', self::$text_domain), $_GET['ad_name']); ?>&status=danger";
			</script>
			<?php
		}

		// Activate

		if(isset($_GET["set_action"]) && $_GET["set_action"] != "") {
			$adsMgn->set_active($_GET["ad_id"], $_GET["set_action"]);
		}

		$cnt_fg = array();

		if (isset($cond))
			$cnt_fg = $adsMgn->get_datas_cnt($cond);
		else
			$cnt_fg = $adsMgn->get_datas_cnt();

		if (isset($cnt_fg["inactive"]) && isset($cnt_fg["active"]))
			$all_p = ceil(($cnt_fg["inactive"]+$cnt_fg["active"])/7);

		if(isset($all_p) && $all_p != 0) {
			if($all_p < $tmp_v) {
				?>
				<script type="text/javascript">
					window.location= "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
				</script>
				<?php
			}
		}

		// Get and Save global settings

		$global_settings = get_option('wpsite_background_takeover_global_settings');

		if ($global_settings === false) {
			$global_settings = array(
				'dom_element'	=> 'body'
			);
		}

		if (isset($_POST['global-submit']) && check_admin_referer('wpsite_background_takeover_global_settings')) {

			$global_settings = array(
				'dom_element'	=> isset($_POST['wpsite-background-takeover-dom-element']) ? stripcslashes(sanitize_text_field($_POST['wpsite-background-takeover-dom-element'])) : 'body',
				'mobile'	=> isset($_POST['wpsite-background-takeover-mobile']) && $_POST['wpsite-background-takeover-mobile'] ? true : false,
			);

			update_option('wpsite_background_takeover_global_settings', $global_settings);

			?>
			<script type="text/javascript">
				window.location= "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
			</script>
			<?php
		}

		require('admin/dashboard.php');
	}

	/*
	 * Callback for new ad page
	 *
	 * @since 1.0
	 */
	static function new_ad_wpto() {

		include_once(dirname(__FILE__)."/include/classes/Ads_DB_WPTO.php");
		$ads_db_wpto = new Ads_DB_WPTO();

		if(isset($_POST["submit"])) {

			$val = array();
			$other_val = array();

			$val['ad_name'] = stripcslashes(trim($_POST['ad_name']));
			$val['ad_type'] = 1;//$_POST['ad_type'];
			$val['ad_group'] = $_POST['ad_group'];

			// Start and End dates

			$val['start_date'] = date('Y-m-d H:i:s', strtotime($_POST["start_date"]));
			$val['end_date'] = date('Y-m-d H:i:s', strtotime($_POST["end_date"]));

			$val['priority'] = $_POST['priority'];

			$tmp_v = $_POST['entire_specific_fg'];

			$idx = 0;

			if (!isset($_POST['is_front_page'])) ++$idx;
			if (!isset($_POST['is_category'])) ++$idx;
			if (!isset($_POST['is_tag'])) ++$idx;
			if (!isset($_POST['is_archive'])) ++$idx;
			if (!isset($_POST['is_single'])) ++$idx;
			if (!isset($_POST['is_page'])) ++$idx;
			if (!isset($_POST['is_post_id'])) ++$idx;
			if (!isset($_POST['is_category_id'])) ++$idx;
			if (!isset($_POST['is_page_id'])) ++$idx;

			$check_post_types = false;
			$post_types = get_post_types(array('public' => true, '_builtin' => false));
			$args_post_type = array();

			foreach ($post_types as $post_type) {
				$args_post_type[$post_type] = isset($_POST['post_type_' . $post_type]) && $_POST['post_type_' . $post_type] ? true : false;
				if ($args_post_type[$post_type]) {
					$check_post_types = true;
				}
			}

			if ($idx == 9 && !$check_post_types) {
				$tmp_v = 0;
			}

			// Trigger

			if ($tmp_v == 1) {
				$val['is_front_page'] = isset($_POST['is_front_page']) && $_POST['is_front_page'] ? true : false;
				$val['is_tag'] = isset($_POST['is_tag']) && $_POST['is_tag'] ? true : false;
				$val['is_archive'] = isset($_POST['is_archive']) && $_POST['is_archive'] ? true : false;

				$val['is_category'] = isset($_POST['is_category']) && $_POST['is_category'] ? true : false;
				$val['is_single'] = isset($_POST['is_single']) && $_POST['is_single'] ? true : false;
				$val['is_page'] = isset($_POST['is_page']) && $_POST['is_page'] ? true : false;

				$val['post_id'] = isset($_POST['post_id']) ? str_replace(' ', '', stripcslashes(sanitize_text_field(rtrim($_POST['post_id'], ',')))) : '';
				$val['category_id'] = isset($_POST['category_id']) ? str_replace(' ', '', stripcslashes(sanitize_text_field(rtrim($_POST['category_id'], ',')))) : '';
				$val['page_id'] = isset($_POST['page_id']) ? str_replace(' ', '', stripcslashes(sanitize_text_field(rtrim($_POST['page_id'], ',')))) : '';

				$val['args'] = serialize(array(
					'post_types' => $args_post_type
				));
			} else {
				$val['is_front_page'] = 0;
				$val['is_tag'] =  0;
				$val['is_archive'] =  0;

				$val['is_category'] =  0;
				$val['is_single'] =  0;
				$val['is_page'] =  0;

				$val['post_id'] =  '';
				$val['category_id'] = '';
				$val['page_id'] =  '';

				$val['args'] = serialize(array(
					'post_types' => $args_post_type
				));
			}

			// Background Image

			$val['img_id'] = isset($_POST['img_id']) ? $_POST['img_id'] : '';

			// Image Type

			if (isset($_POST['img_type'])) {
				$other_val['img_type'] = $_POST['img_type'];
			} else {
				$other_val['img_type'] = '';
			}

			// Image URL

			if (isset($_POST['img_url'])) {
				$other_val['img_url'] = sanitize_text_field($_POST['img_url']);
			} else {
				$other_val['img_url'] = '';
			}

			// Image ID

			if (isset($_POST['img_id'])) {
				$other_val['img_id'] = sanitize_text_field($_POST['img_id']);
			} else {
				$other_val['img_id'] = '';
			}

			// Link Option

			if (isset($_POST['link_option']) && $_POST['link_option'] == 1) {
				$other_val['link_option'] = 1;
			} else {
				$other_val['link_option'] = 0;
			}

			// Link Option Both

			if ( $other_val['link_option'] == 0) {
				$other_val['link_url_left'] = sanitize_text_field($_POST['link_url_both']);
				$other_val['link_url_right'] = sanitize_text_field($_POST['link_url_both']);
				$other_val['link_url_left_target'] = sanitize_text_field($_POST['link_url_both_target']);
				$other_val['link_url_right_target'] = sanitize_text_field($_POST['link_url_both_target']);
				//$other_val['link_url_left_rel'] = sanitize_text_field($_POST['link_url_both_rel']);
				//$other_val['link_url_right_rel'] = sanitize_text_field($_POST['link_url_both_rel']);
			}

			// Link Option Right and Left

			if ( $other_val['link_option'] == 1) {
				$other_val['link_url_left'] = sanitize_text_field($_POST['link_url_left']);
				$other_val['link_url_right'] = sanitize_text_field($_POST['link_url_right']);
				$other_val['link_url_left_target'] = sanitize_text_field($_POST['link_url_left_target']);
				$other_val['link_url_right_target'] = sanitize_text_field($_POST['link_url_right_target']);
				//$other_val['link_url_left_rel'] = sanitize_text_field($_POST['link_url_left_rel']);
				//$other_val['link_url_right_rel'] = sanitize_text_field($_POST['link_url_right_rel']);
			}

			// Background Repeat

			if (isset($_POST['bg_repeat'])) {
				$other_val['bg_repeat'] = $_POST['bg_repeat'];
			} else {
				$other_val['bg_repeat'] = '';
			}

			// Background Attach

			if (isset($_POST['bg_attach'])) {
				$other_val['bg_attach'] = $_POST['bg_attach'];
			} else {
				$other_val['bg_attach'] = '';
			}

			// Background Stretch

			if (isset($_POST['bg_strech'])) {
				$other_val['bg_strech'] = $_POST['bg_strech'];
			} else {
				$other_val['bg_strech'] = '';
			}

			// Background Color

			if (isset($_POST['bg_color'])) {
				$other_val['bg_color'] = trim($_POST['bg_color']);
			} else {
				$other_val['bg_color'] = '';
			}

			if($_POST["submit"] == "Save") {
				$ads_db_wpto->add_data($val, $other_val);
				?>
				<script type="text/javascript">
					window.location= "<?php echo get_admin_url() ; ?>admin.php?page=<?php echo self::$dashboard_page; ?>&message=<?php printf(__('%s was just created!', self::$text_domain), $val['ad_name']); ?>&status=success";
				</script>
				<?php
			}

			if($_POST["submit"] == "Update") {
				$val['ad_id'] = $_GET['ad_id'];
				$ads_db_wpto->update_data($val, $other_val);
				?>
				<script type="text/javascript">
					window.location= "<?php echo get_admin_url() ; ?>admin.php?page=<?php echo self::$dashboard_page; ?>&message=<?php printf(__('Updates to %s were just saved!', self::$text_domain), $val['ad_name']); ?>&status=success";
				</script>
				<?php
			}
		}

		// Get editing data of current background ad

		$edit_data = $ads_db_wpto->get_datas_byid(isset($_GET["ad_id"]) ? $_GET["ad_id"] : null);

		$edit_data["other_val"]["link_option"] = isset($edit_data["other_val"]["link_option"]) ? $edit_data["other_val"]["link_option"] : 0;

		if (!isset($edit_data["other_val"]["link_url_both_target"])) {
			$edit_data["other_val"]["link_url_both_target"] = '_blank';
		}

		if (!isset($edit_data["other_val"]["link_url_left_target"])) {
			$edit_data["other_val"]["link_url_left_target"] = '_blank';
		}

		if (!isset($edit_data["other_val"]["link_url_right_target"])) {
			$edit_data["other_val"]["link_url_right_target"] = '_blank';
		}

		$edit_data["other_val"]["bg_repeat"] = isset($edit_data["other_val"]["bg_repeat"]) ? $edit_data["other_val"]["bg_repeat"] : 'no-repeat';
		$edit_data["other_val"]["bg_attach"] = isset($edit_data["other_val"]["bg_attach"]) ? $edit_data["other_val"]["bg_attach"] : 'fixed';
		$edit_data["other_val"]["bg_strech"] = isset($edit_data["other_val"]["bg_strech"]) ? $edit_data["other_val"]["bg_strech"] : 'no';
		$edit_data["other_val"]["bg_color"] = isset($edit_data["other_val"]["bg_color"]) ? $edit_data["other_val"]["bg_color"] : '#e6e6e6';

		$edit_data["basic_val"]["priority"] = isset($edit_data["basic_val"]["priority"]) ? $edit_data["basic_val"]["priority"] : 1;
		$edit_data["basic_val"]["is_front_page"] = isset($edit_data["basic_val"]["is_front_page"]) ? $edit_data["basic_val"]["is_front_page"] : 0;
		$edit_data["basic_val"]["is_category"] = isset($edit_data["basic_val"]["is_category"]) ? $edit_data["basic_val"]["is_category"] : 0;
		$edit_data["basic_val"]["is_tag"] = isset($edit_data["basic_val"]["is_tag"]) ? $edit_data["basic_val"]["is_tag"] : 0;
		$edit_data["basic_val"]["is_archive"] = isset($edit_data["basic_val"]["is_archive"]) ? $edit_data["basic_val"]["is_archive"] : 0;
		$edit_data["basic_val"]["is_single"] = isset($edit_data["basic_val"]["is_single"]) ? $edit_data["basic_val"]["is_single"] : 0;
		$edit_data["basic_val"]["is_page"] = isset($edit_data["basic_val"]["is_page"]) ? $edit_data["basic_val"]["is_page"] : 0;
		$edit_data["basic_val"]["post_id"] = isset($edit_data["basic_val"]["post_id"]) ? $edit_data["basic_val"]["post_id"] : 0;
		$edit_data["basic_val"]["category_id"] = isset($edit_data["basic_val"]["category_id"]) ? $edit_data["basic_val"]["category_id"] : 0;
		$edit_data["basic_val"]["page_id"] = isset($edit_data["basic_val"]["page_id"]) ? $edit_data["basic_val"]["page_id"] : 0;

		require('admin/add_edit.php');
	}

	/*
	 * Callback for new ad group page
	 *
	 * @since 1.0
	 */
	static function ad_groups_wpto() {

		// Database

		include_once(dirname(__FILE__)."/include/classes/Ad_Groups_DB_WPTO.php");
		$adGroupsMgn = new Ad_Groups_Mgn();

		if(isset($_GET["orderby"]))
			$tmp_url .= "&orderby=".$_GET["orderby"];
		if(isset($_GET["order"]))
			$tmp_url .= "&order=".$_GET["order"];
		if(isset($_GET["s"]))
			$tmp_url .= "&s=".$_GET["s"];

		$tmp = $adGroupsMgn->get_datas();

		$all_p = ceil(count($tmp)/7);

		if(isset($all_p) && $all_p != 0) {
			if(isset($tmp_v) && $all_p < $tmp_v) {
			?>
			<script type="text/javascript">
				window.location= "<?php echo get_admin_url() ; ?>admin.php?page=<?php echo self::$group_page; ?>";
			</script>
			<?php
			}
		}

		if(isset($_GET["paged"])) {
			$tmp_url .= "&paged=".$_GET["paged"];
		}

		// Submit

		if(isset($_POST["submit"])) {

			// Update group

			if (isset($_GET["action"]) && $_GET["action"] == "edit" && isset($_GET["adgroup_id"])) {
				$data_tmp["id"] = $_GET["adgroup_id"];
				$data_tmp["name"] = $_POST["adgroup_name"];
				$data_tmp["notes"] = $_POST["adgroup_notes"];

				$adGroupsMgn->update_data($data_tmp);

				?>
				<script type="text/javascript">
					window.location= "<?php echo get_admin_url() . "admin.php?page=" . self::$group_page;?>&message=<?php printf(__('Updates to %s were just saved!', self::$text_domain), $_POST["adgroup_name"]); ?>&status=success";
				</script>
				<?php
			}

			// Add new group

			else {
				$data_tmp["name"] = $_POST["adgroup_name"];
				$data_tmp["notes"] = $_POST["adgroup_notes"];

				$adGroupsMgn->add_data($data_tmp);

				?>
				<script type="text/javascript">
					window.location= "<?php echo get_admin_url() . "admin.php?page=" . self::$group_page;?>&message=<?php printf(__('%s was just created!', self::$text_domain), $_POST["adgroup_name"]); ?>&status=success";
				</script>
				<?php
			}
		}

		// Delete Ad Group

		if (isset($_GET["action"]) && $_GET["action"] == "delete") {

			// Check to see if they are deleting the last group

			$groups = $adGroupsMgn->get_datas();

			if (count($groups) > 1 && isset($_GET["adgroup_id"])) {
				$adGroupsMgn->delete_data($_GET["adgroup_id"]);

				?>
				<script type="text/javascript">
					window.location= "<?php echo get_admin_url() . "admin.php?page=" . self::$group_page;?>&message=<?php printf(__('%s was just deleted!', self::$text_domain), $_GET["adgroup_name"]); ?>&status=danger";
				</script>
				<?php

			} else {
				?>
				<script type="text/javascript">
					window.location= "<?php echo get_admin_url() . "admin.php?page=" . self::$group_page;?>&message=<?php _e('Cannot delete group because one group must always exist!', self::$text_domain); ?>&status=danger";
				</script>
				<?php
			}
		}

		require('admin/group_dashboard.php');
	}

	/**
	 * Displays content for the Stats page
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function stats() {

		// Create Table if one does not exist

		WPsite_Stats_BT::createTable();

		// Export data

		if (isset($_GET['export_data']) && $_GET['export_data'] == 'true' && check_admin_referer(self::$prefix . 'export_data')) {

			$start_date = date(WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
			$end_date = date(WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT, strtotime(current_time('mysql')));

			if (isset($_GET[self::$prefix_dash . 'start-date']) && $_GET[self::$prefix_dash . 'start-date'] != '') {
				$start_date = date(WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'start-date']));
			}

			if (isset($_GET[self::$prefix_dash . 'end-date']) && $_GET[self::$prefix_dash . 'end-date'] != '') {
				$end_date = date(WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'end-date']));
			}

			global $wpdb;
			$background_takeover_stats = WPsite_Stats_BT::getStats($start_date, $end_date, $_GET['background_takeover_id']);

			require_once(dirname(__FILE__)."/include/classes/Ads_DB_WPTO.php");
			$ads_db_wpto = new Ads_DB_WPTO();

			$background_takeovers = $wpdb->get_results("SELECT * FROM `" . $ads_db_wpto->tb_nm . "`");

			foreach ($background_takeovers as $background_takeover) {
				foreach ($background_takeover_stats as $key => $background_takeover_stat) {
					if ($background_takeover->ad_id == $background_takeover_stat['background_takeover_id']) {
						$background_takeover_stats[$key] = array('background_takeover_name' => $background_takeover->ad_name) + $background_takeover_stats[$key];

						$clicks = $background_takeover_stats[$key]['left_clicks'] + $background_takeover_stats[$key]['right_clicks'];

						$background_takeover_stats[$key]['click-through-rate'] = round(($clicks/$background_takeover_stats[$key]['impressions']) * 100,2) . '%';
					}
				}
			}

			// Unset indexes

			foreach ($background_takeover_stats as $key => $background_takeover_stat) {
				unset($background_takeover_stats[$key]['id']);
				unset($background_takeover_stats[$key]['background_takeover_id']);
			}

			$filename =  self::$prefix . 'stats.csv';
			$export_file = fopen(WPSITE_WALLPAPER_TAKEOVER_PLUGIN_DIR . '/exports/' . $filename, "w");
			fputcsv($export_file, array('Background Takeover Name', 'Date', 'Impressions', 'Left Clicks', 'Right Clicks', 'Click-Through Rate'));

			foreach (array_reverse($background_takeover_stats) as $background_takeover_stat) {
			    fputcsv($export_file, $background_takeover_stat);
			}

			fclose($export_file);

			?>
			<script type="text/javascript">
				window.location = '<?php echo WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/exports/download.php?filename=' . $filename; ?>';
			</script>
			<?php
		}

		wp_enqueue_script(self::$prefix . 'stats_js', WPSITE_WALLPAPER_TAKEOVER_PLUGIN_URL . '/js/stats.js', array('jquery'));
		wp_localize_script(self::$prefix . 'stats_js', 'wps_bt_stats_data', array(
			'prefix_dash' 		=> self::$prefix_dash,
			'today'				=> date('m/d/Y')
		));

		require('admin/stats.php');
	}

	/**
	 * Load all stats using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function stats_load() {

		// Get Stats

		$start_date = date(WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(WPSITE_WALLPAPER_TAKEOVER_DATE_FORMAT, strtotime($post_end_date));
		}

		global $wpdb;

		// All background_takeover stats

		if (isset($_POST['background_takeover_name']) && $_POST['background_takeover_name'] == '') {

			$stats = WPsite_Stats_BT::getStats($start_date, $end_date);

			require_once(dirname(__FILE__)."/include/classes/Ads_DB_WPTO.php");
			$ads_db_wpto = new Ads_DB_WPTO();

			$background_takeovers = $wpdb->get_results("SELECT * FROM `" . $ads_db_wpto->tb_nm . "`");

			$background_takeover_stats = array();

			foreach ($background_takeovers as $background_takeover) {
				foreach ($stats as $stat) {
					if ($background_takeover->ad_id == $stat['background_takeover_id']) {
						$background_takeover_stats[$background_takeover->ad_id] = array(
							'background_takeover_id'	=> $stat['background_takeover_id'],
							'background_takeover_name'	=> $background_takeover->ad_name,
							'date'			=> $stat['date'],
							'impressions'	=> isset($background_takeover_stats[$background_takeover->ad_id]['impressions']) ? $background_takeover_stats[$background_takeover->ad_id]['impressions'] + $stat['impressions'] : $stat['impressions'],
							'left_clicks'		=> isset($background_takeover_stats[$background_takeover->ad_id]['left_clicks']) ? $background_takeover_stats[$background_takeover->ad_id]['left_clicks'] + $stat['left_clicks'] : $stat['left_clicks'],
							'right_clicks'		=> isset($background_takeover_stats[$background_takeover->ad_id]['right_clicks']) ? $background_takeover_stats[$background_takeover->ad_id]['right_clicks'] + $stat['right_clicks'] : $stat['right_clicks'],
						);
					}
				}
			}

			$impressions_total = 0;
			$clicks_total = 0;
			foreach ($background_takeover_stats as $background_takeover_stat) {
			    $impressions_total += $background_takeover_stat['impressions'];
			    $clicks_total += $background_takeover_stat['left_clicks'] + $background_takeover_stat['right_clicks'];
			}

			$stats_content = '
			<div class="' . self::$prefix_dash . 'stats-total-container well col-xs-12">
				<div class="' . self::$prefix_dash . 'stats-totals col-xs-4">
					<span>' . __('Impressions', self::$text_domain) . '</span><br/>
					<span class="' . self::$prefix_dash . 'stats-totals-text">' . $impressions_total . '</span><br/>
				</div>
				<div class="' . self::$prefix_dash . 'stats-totals col-xs-4">
					<span>' . __('Clicks', self::$text_domain) . '</span><br/>
					<span class="' . self::$prefix_dash . 'stats-totals-text">' . $clicks_total . '</span><br/>
				</div>
				<div class="' . self::$prefix_dash . 'stats-totals col-xs-4">
					<span>' .  __('Click-Through Rate', self::$text_domain) . '</span><br/>
					<span class="' . self::$prefix_dash . 'stats-totals-text">' . round(($clicks_total/$impressions_total) * 100,2) . '%</span><br/>
				</div>
			</div>

			<div style="clear:both"></div>

			<canvas id="' . self::$prefix_dash . 'line-graph"></canvas>

			<div class="table-responsive">
				<table class="table table-condensed table-striped">

					<thead>
						<th>' . __('Background Takeover', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-globe"></span> ' . __('Impressions', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Left Clicks', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Right Clicks', self::$text_domain) . '</th>
						<th>' . __('Click-Through Rate', self::$text_domain) . '</th>
					</thead>
					<tfoot>
						<th>' . __('Background Takeover', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-globe"></span> ' . __('Impressions', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Left Clicks', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Right Clicks', self::$text_domain) . '</th>
						<th>' . __('Click-Through Rate', self::$text_domain) . '</th>
					</tfoot>';

					foreach ($background_takeover_stats as $background_takeover_stat) {

						$stats_content .= '<tr>
							<td>
								<a href="' . admin_url() . 'admin.php?page=' . self::$stats_page . '&background_takeover_id=' . $background_takeover_stat['background_takeover_id'] . '&background_takeover_name=' . $background_takeover_stat['background_takeover_name'] . '" role="button" class="btn btn-xs btn-primary">
									' .  $background_takeover_stat['background_takeover_name'] . '
								</a>
							</td>
							<td>' . $background_takeover_stat['impressions'] . '</td>';

							$stats_content .= '
							<td>' . $background_takeover_stat['left_clicks'] . '</td>
							<td>' . $background_takeover_stat['right_clicks'] . '</td>
							<td>' . ($background_takeover_stat['impressions'] > 0 ? round((($background_takeover_stat['left_clicks']+$background_takeover_stat['right_clicks']) / $background_takeover_stat['impressions']) * 100, 2) : '0') . '%</td>';

						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		// Single background_takeover stats

		else if (isset($_POST['background_takeover_name']) && $_POST['background_takeover_name'] != '') {

			$background_takeover_stats = WPsite_Stats_BT::getStats($start_date, $end_date, $_POST['background_takeover_id']);

			require_once(dirname(__FILE__)."/include/classes/Ads_DB_WPTO.php");
			$ads_db_wpto = new Ads_DB_WPTO();

			$background_takeovers = $wpdb->get_results("SELECT * FROM `" . $ads_db_wpto->tb_nm . "`");

			foreach ($background_takeovers as $background_takeover) {
				foreach ($background_takeover_stats as $key => $background_takeover_stat) {
					if ($background_takeover->ad_id == $background_takeover_stat['background_takeover_id']) {
						$background_takeover_stats[$key] = array('background_takeover_name' => $background_takeover->ad_name) + $background_takeover_stats[$key];
					}
				}
			}

			// Unset indexs

			foreach ($background_takeover_stats as $key => $background_takeover_stat) {
				unset($background_takeover_stats[$key]['id']);
				unset($background_takeover_stats[$key]['background_takeover_id']);
			}

			$impressions_total = 0;
			$clicks_total = 0;
			foreach ($background_takeover_stats as $background_takeover_stat) {
			    $impressions_total += $background_takeover_stat['impressions'];
			    $clicks_total += $background_takeover_stat['left_clicks'] + $background_takeover_stat['right_clicks'];
			}

			$stats_content = '
			<div class="' . self::$prefix_dash . 'stats-total-container well col-xs-12">
				<div class="' . self::$prefix_dash . 'stats-totals col-xs-4">
					<span>' . __('Impressions', self::$text_domain) . '</span><br/>
					<span class="' . self::$prefix_dash . 'stats-totals-text">' . $impressions_total . '</span><br/>
				</div>
				<div class="' . self::$prefix_dash . 'stats-totals col-xs-4">
					<span>' . __('Clicks', self::$text_domain) . '</span><br/>
					<span class="' . self::$prefix_dash . 'stats-totals-text">' . $clicks_total . '</span><br/>
				</div>
				<div class="' . self::$prefix_dash . 'stats-totals col-xs-4">
					<span>' .  __('Click-Through Rate', self::$text_domain) . '</span><br/>
					<span class="' . self::$prefix_dash . 'stats-totals-text">' . round(($clicks_total/$impressions_total) * 100,2) . '%</span><br/>
				</div>
			</div>

			<div style="clear:both"></div>

			<canvas id="' . self::$prefix_dash . 'line-graph"></canvas>

			<div class="table-responsive">
				<table class="table table-condensed table-striped">

					<thead>
						<th>' . __('Date', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Impressions', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Left Clicks', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Right Clicks', self::$text_domain) . '</th>
						<th>' . __('Click-Through Rate', self::$text_domain) . '</th>
					</thead>
					<tfoot>
						<th>' . __('Date', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Impressions', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Left Clicks', self::$text_domain) . '</th>
						<th class="' . self::$prefix_dash . 'clicks-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Right Clicks', self::$text_domain) . '</th>
						<th>' . __('Click-Through Rate', self::$text_domain) . '</th>
					</tfoot>';

					foreach (array_reverse($background_takeover_stats) as $background_takeover_stat) {

						$stats_content .= '<tr>
							<td>' . date('M j Y', strtotime($background_takeover_stat['date'])) . '</td>
							<td>' . $background_takeover_stat['impressions'] . '</td>';

							$stats_content .= '
							<td>' . $background_takeover_stat['left_clicks'] . '</td>
							<td>' . $background_takeover_stat['right_clicks'] . '</td>
							<td>' . ($background_takeover_stat['impressions'] > 0 ? round((($background_takeover_stat['left_clicks']+$background_takeover_stat['right_clicks']) / $background_takeover_stat['impressions']) * 100, 2) : '0') . '%</td>';

						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		echo json_encode(array('stats_content' => $stats_content, 'background_takeover_stats' => $background_takeover_stats));

		die(); // this is required to terminate immediately and return a proper response
	}

	/*
	 * Callback for help page
	 *
	 * @since 1.0
	 */
	static function ad_help_wpto(){
		?>
		<h1><?php _e("WPsite Wallpaper Takeover Help", self::$text_domain); ?></h1>
		<?php
	}

	/*
	 * Get the image attachment id
	 *
	 * @since 1.0
	 */
	static function get_attachment_id_from_src ($image_src) {
	    global $wpdb;
	    $id = $wpdb->get_var($wpdb->prepare("SELECT ID FROM {$wpdb->posts} WHERE guid= %s", $image_src));

	    if($id == null){
	        $image_src = basename ( $image_src );
	        $id = $wpdb->get_var($wpdb->prepare("SELECT post_id FROM {$wpdb->postmeta}  WHERE meta_key = '_wp_attachment_metadata' AND meta_value LIKE %s", '%' . $image_src . '%'));
	    }
	    return $id;
	}

	/*
	 * Hook for home
	 *
	 * @since 1.0
	 */
	static function is_home_wpto() {

		// Check if mobile

		$global_settings = get_option('wpsite_background_takeover_global_settings');

		if ($global_settings === false) {
			$global_settings = self::$default_global_settings;
		}

		if (!class_exists("Mobile_Detect")) {
			require_once(dirname(__FILE__)."/include/mobile-detect/Mobile_Detect.php");
		}

		$detect = new Mobile_Detect;

		if (!$global_settings['mobile'] && ($detect->isMobile() || $detect->isTablet())) {
			return false;
		}

		require_once(dirname(__FILE__)."/include/classes/Ads_DB_WPTO.php");

		$ads_db_wpto = new Ads_DB_WPTO();

		$custom_post_types = get_post_types(array('public' => true, '_builtin' => false));

		// Home

		if (is_home() || is_front_page()) {
			$val = $ads_db_wpto->get_relevant_data_for_frontpage();
		}

		// Archive

		if (is_archive()) {
			$val = $ads_db_wpto->get_relevant_data_for_archive();
		}

		// Tag

		if (is_tag()) {
			$val = $ads_db_wpto->get_relevant_data_for_tag();
		}

		// Post

		if (is_single() && (!is_singular($custom_post_types) || (isset($custom_post_types) && is_array($custom_post_types) && count($custom_post_types) == 0))) {
			$post_id = get_the_ID();
			$val = $ads_db_wpto->get_relevant_data_for_post($post_id);
		}

		// Custom Post Type

		if (isset($custom_post_types) && is_array($custom_post_types) && count($custom_post_types) > 0 && is_singular($custom_post_types)) {
			$custom_post_type = get_post_type(get_the_ID());
			$val = $ads_db_wpto->get_relevant_data_for_custom_post_type($custom_post_type);
		}

		// Page

		if (is_page()) {
			$page_id = get_the_ID();
			$val = $ads_db_wpto->get_relevant_data_for_page($page_id);
		}

		// Category

		if (is_category()) {
			$category = single_term_title("", false);
			$catid = get_cat_ID( $category );

			$val = $ads_db_wpto->get_relevant_data_for_category($catid);
		}

		// Site

		if (!isset($val)) {
			$val = $ads_db_wpto->get_relevant_data_for_site();
		}

		if (isset($val) && is_array($val)) {
			$css = self::get_css_wpto($val);

			ob_start(); //start buffer
			$page = ob_get_contents();
			ob_end_clean();
			echo $page . $css;
		}
	}

	/*
	 * Get the css for something
	 * @param	array	$val
	 * @since 1.0
	 */
	static function get_css_wpto($val) {

		if (!isset($val) || count($val) <= 0) {
			return false;
		}

		$global_settings = get_option('wpsite_background_takeover_global_settings');

		if ($global_settings === false) {
			$global_settings = self::$default_global_settings;
		}

		// CSS

		$special_content = '';
		$special_content .= '<style type="text/css" id="custom-background-css">';

		$bg_color = isset($val["bg_color"]) ? $val["bg_color"] : '';
		$bg_repeat = isset($val["bg_repeat"]) ? $val["bg_repeat"] : '';
		$bg_attachment = isset($val["bg_attach"]) ? $val["bg_attach"] : '';
		$src = '';

		// Check the ad image type

		if (!isset($val["img_type"])) {
			$val['img_type'] = 'media';
			$val['img_id'] = $val['img_url'];
		}

		if (isset($val["img_type"]) && $val["img_type"] == 'url') {
			$src = $val["img_url"];
		} else {
			$image_attributes = wp_get_attachment_image_src($val["img_id"], 'full'); // returns an array

			if( $image_attributes ) {
				$src = $image_attributes[0];
			} else {
				$src = '';
			}
		}

		// Add all the custom styling for displaying an ad

		$special_content .= $global_settings['dom_element'] . ' { background-position:top center !important;';
		$special_content .= 'background-color: ' . $bg_color .' !important;';
		$special_content .= 'background-image: url("' . $src . '") !important;';
		$special_content .= 'background-repeat: ' . $bg_repeat .' !important;';
		$special_content .= 'background-attachment: ' . $bg_attachment . ' !important;';

		if(isset($val["bg_strech"]) && $val["bg_strech"] == 'yes') {
			$special_content .= '-webkit-background-size: cover !important; -moz-background-size: cover !important; -o-background-size: cover !important; background-size: cover !important;';
		}

		$special_content .= '}';

		$special_content .= '</style>';

		$special_content .= '<div id="' . self::$prefix_dash . 'background-takeover-id" data-background-takeover-id="' . $val['ad_id'] . '"></div>';

		// Script

		wp_enqueue_script('wpsite_clickable_js', plugins_url('js/wpsite_clickable.js', __FILE__), array('jquery'), false, true);
		wp_localize_script('wpsite_clickable_js', 'wpsite_clickable_data', array(
			'prefix_dash'			=> self::$prefix_dash,
	    	'ajaxurl'				=> admin_url( 'admin-ajax.php' ),
			'link_left' 			=> isset($val["link_url_left"]) ? $val["link_url_left"] : '',
			'link_right' 			=> isset($val["link_url_right"]) ? $val["link_url_right"] : '',
			'link_both' 			=> isset($val["link_url_both"]) ? $val["link_url_both"] : '',
			'link_option'			=> isset($val["link_option"]) ? $val["link_option"] : '',
			'link_url_left_target'	=> isset($val["link_url_left_target"]) ? $val["link_url_left_target"] : '_blank',
			'link_url_right_target'	=> isset($val["link_url_right_target"]) ? $val["link_url_right_target"] : '_blank',
			//'link_url_left_rel'		=> isset($val["link_url_left_rel"]) ? $val["link_url_left_rel"] : false,
			//'link_url_right_rel'	=> isset($val["link_url_right_rel"]) ? $val["link_url_right_rel"] : false,
			'dom_element'			=> isset($global_settings['dom_element']) && $global_settings['dom_element'] != '' ? $global_settings['dom_element'] : 'body',
		));

		return $special_content;
	}

	/**
	 * Everyday check if there is a record for impressions or clicks for each fireabr.
	 * If there is no record than add one and set it to 0..
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function initialize_background_takeover_stats_daily() {
		WPsite_Stats_BT::initialize_background_takeover_stats();
	}
}
?>